/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements. See the NOTICE file distributed with this
 * work for additional information regarding copyright ownership. The ASF
 * licenses this file to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.apithefire.servlet.wicket;

import org.apache.wicket.protocol.http.IWebApplicationFactory;
import org.apache.wicket.protocol.http.WebApplication;
import org.apache.wicket.protocol.http.WicketFilter;
import org.apache.wicket.protocol.http.WicketServlet;
import org.apithefire.util.lang.Objects;

public class EmbeddedWicketServlet extends WicketServlet {
	
	private final WebApplication webApplication;
	
	public EmbeddedWicketServlet(WebApplication webApplication) {
		this.webApplication = Objects.nonNull(webApplication);
	}
	
	public WebApplication getWebApplication() {
		return webApplication;
	}

	@Override
	protected WicketFilter newWicketFilter() {
		return new WicketFilter() {
			@Override
			protected IWebApplicationFactory getApplicationFactory() {
				return new IWebApplicationFactory() {
					public WebApplication createApplication(WicketFilter filter) {
						return webApplication;
					}
				};
			}
		};
	}

}
